;;;; -*- Mode: Lisp; Syntax: ANSI-Common-Lisp; Base: 10 -*-
;;;; *************************************************************************
;;;; FILE IDENTIFICATION
;;;;
;;;; Name:          package.lisp
;;;; Purpose:       Package definition for kmrcl package
;;;; Programmer:    Kevin M. Rosenberg
;;;; Date Started:  Apr 2000
;;;;
;;;; $Id: package.lisp,v 1.24 2003/05/02 22:30:26 kevin Exp $
;;;;
;;;; This file, part of KMRCL, is Copyright (c) 2002 by Kevin M. Rosenberg
;;;;
;;;; KMRCL users are granted the rights to distribute and use this software
;;;; as governed by the terms of the Lisp Lesser GNU Public License
;;;; (http://opensource.franz.com/preamble.html), also known as the LLGPL.
;;;; *************************************************************************

(declaim (optimize (debug 3) (speed 3) (safety 1) (compilation-speed 0)))

(in-package :cl-user)

(defpackage #:kmrcl
  (:nicknames :kl)
  (:use :common-lisp)
  (:export
   #:ensure-integer
   #:mklist
   #:filter
   #:appendnew
   #:memo-proc
   #:memoize
   #:defun-memo
   #:_f
   #:compose
   #:until
   #:while
   #:for
   #:mapappend
   #:mapcar-append-string
   #:mapcar2-append-string
   #:delimited-string-to-list
   #:list-to-delimited-string
   #:flatten
   #:indent-spaces
   #:print-list
   #:print-rows
   #:file-subst
   #:stream-subst
   #:remove-tree-if
   #:find-tree
   #:with-each-file-line
   #:with-each-stream-line
   #:remove-keyword
   #:remove-keywords
   #:nsubseq
   
   ;; macros.lisp
   #:time-iterations
   #:in
   #:mean
   #:with-gensyms
   #:let-if
   #:let-when
   #:aif
   #:awhen
   #:awhile
   #:aand
   #:acond
   #:alambda
   #:it
   #:mac
   
   ;; files.lisp
   #:print-file-contents
   #:read-file-to-string
   #:read-file-to-strings
   
   ;; strings.lisp
   #:string-append
   #:count-string-words
   #:substitute-string-for-char
   #:string-trim-last-character
   #:nstring-trim-last-character
   #:string-hash
   #:string-not-null?
   #:whitespace?
   #:not-whitespace?
   #:string-ws?
   #:string-invert
   #:escape-xml-string
   #:make-usb8-array
   #:usb8-array-to-string
   #:string-to-usb8-array
   #:substitute-chars-strings
   #:add-sql-quotes
   #:escape-backslashes
   
   ;; symbols.lisp
   #:ensure-keyword
   #:concat-symbol
   #:concat-symbol-pkg
   #:show
   #:show-variables
   #:show-functions
   
   ;; From attrib-class.lisp
   #:attributes-class
   #:slot-attribute
   
   #:generalized-equal
   
   ;; From buffered input
   
   #:make-fields-buffer
   #:read-buffered-fields
   
   ;; From datetime.lisp
   #:pretty-date
   #:date-string
   #:print-float-units
   #:print-seconds
   
   ;; From random.lisp
   #:seed-random-generator
   #:random-choice
   
   ;; From telnet-server.lisp
   #:start-telnet-server	  
   
   ;; From web-utils
   #:*base-url*
   #:base-url!
   #:make-url
   #:*standard-html-header*
   #:*standard-xhtml-header*
   #:*standard-xml-header*
   #:user-agent-ie-p
   
   ;; From xml-utils
   #:wrap-with-xml
   #:xml-tag-contents
   #:positions-xml-tag-contents
   #:xml-cdata
   
   ;; From console
   *console-msgs*
   cmsg
   cmsg-c
   cmsg-add
   cmsg-remove
   fixme
   ))



